=== checker/Makefile ===
# -----------------------------------------------------------------------------
#  (C) Altran Praxis Limited
# -----------------------------------------------------------------------------
# 
#  The SPARK toolset is free software; you can redistribute it and/or modify it
#  under terms of the GNU General Public License as published by the Free
#  Software Foundation; either version 3, or (at your option) any later
#  version. The SPARK toolset is distributed in the hope that it will be
#  useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
#  Public License for more details. You should have received a copy of the GNU
#  General Public License distributed with the SPARK toolset; see file
#  COPYING3. If not, go to http://www.gnu.org/licenses for a complete copy of
#  the license.
# 
# =============================================================================

.NOTPARALLEL:

################################################################################
# PURPOSE
#-------------------------------------------------------------------------------
# Makefile for the Checker.
# For Linux, Windows, Solaris or Mac OS X (aka Darwin).
################################################################################

################################################################################
# BUILD CONFIGURATION
################################################################################

# Name of the output program.
OUTPUT_NAME:=checker

# Location of root.
ROOT:=..

# Location of common.
COMMON:=${ROOT}/common

include ${COMMON}/Makefile.inc

################################################################################
# PLATFORM SPECIFIC CONFIGURATION
################################################################################

# Darwin (Mac OS X).
ifeq (${TARGET},Darwin)
    # Modify PATH to pick up Apple's gcc before GNAT Pro
    PATH:=/usr/bin:${PATH}
endif

################################################################################
# TARGETS
################################################################################

all: ${OUTPUT_NAME}${EXE_EXTN} build_manifest

# Note that the build assumes PATH is set to include SICSTUS binaries and (on
# Windows) MS VC Tools and LIB and INCLUDE are set to point at MS VC libraries
# and includes respectively.

${OUTPUT_NAME}${EXE_EXTN}: *.pro
	sicstus ${SICSTUS_SWITCHES} --goal "compile('checker.pro'), buildsav."
	spld ${SPLD_CONF} -o $@ --static --resources=${OUTPUT_NAME}${SAV_EXTN}=/${OUTPUT_NAME}${SAV_EXTN},${SICSTUS_LIBS}

# Manifest only required on Windows.
ifeq ($(findstring ${TARGET},Windows),${TARGET})
build_manifest:
	# Copy over the correct manifest file for this windows build.
	cp ${OUTPUT_NAME}.windows.manifest ${OUTPUT_NAME}${EXE_EXTN}.manifest
else
build_manifest:
endif

spxref:
	spxref -R -i spxref.pro checker.pro -w spxref_warning.txt -x spxref_cross.txt -m spxref_ported.txt -u spxref_undefined.txt

spxrefplain: spxref
	# Normalize anonymous prolog variables.
	sed -e 's/_[0-9][0-9]*/_/g' spxref_undefined.txt > spxref_undefined.txt.tmp
	mv spxref_undefined.txt.tmp spxref_undefined.txt

# Cleaning code base
#===================

clean:
	rm -f checker.sav checker.exp checker.ilk checker.lib checker.pdb

reallyclean: clean
	rm -f ${OUTPUT_NAME}${EXE_EXTN} ${OUTPUT_NAME}${EXE_EXTN}.manifest
	rm -f spxref_warning.txt spxref_cross.txt spxref_ported.txt spxref_undefined.txt

################################################################################
# END-OF-FILE
