=== sparkformat/Makefile ===
# -----------------------------------------------------------------------------
#  (C) Altran Praxis Limited
# -----------------------------------------------------------------------------
# 
#  The SPARK toolset is free software; you can redistribute it and/or modify it
#  under terms of the GNU General Public License as published by the Free
#  Software Foundation; either version 3, or (at your option) any later
#  version. The SPARK toolset is distributed in the hope that it will be
#  useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
#  Public License for more details. You should have received a copy of the GNU
#  General Public License distributed with the SPARK toolset; see file
#  COPYING3. If not, go to http://www.gnu.org/licenses for a complete copy of
#  the license.
# 
# =============================================================================

################################################################################
# PURPOSE
#-------------------------------------------------------------------------------
# Makefile for SPARKFormat
# For Linux, Windows, Solaris or Mac OS X (aka Darwin).
################################################################################

################################################################################
# BUILD CONFIGURATION
################################################################################

# Name of the output program.
OUTPUT_NAME:=sparkformat

# Location of root.
ROOT:=..

# Location of common.
COMMON:=${ROOT}/common

include ${COMMON}/Makefile.inc

################################################################################
# PLATFORM SPECIFIC CONFIGURATION
################################################################################

# Windows.
ifeq (${TARGET},Windows)
    # The --stack option is Windows specific, and supports setting the
    # 'StackCommitSize' and 'StackReserveSize'.  The interpretation of
    # these values is not treated consistently across different
    # Windows versions. Experience and testing on various Windows
    # versions has led to the current stack size being set at:
    # 0x10000000,0x100000 Do not change this value without considering
    # its full ramifications.
    LINK_ARGS:=-Xlinker --stack=0x10000000,0x100000
endif

# Solaris.
ifeq (${TARGET},SunOS)
    LINK_ARGS:=
endif

# Linux.
ifeq (${TARGET},Linux)
    LINK_ARGS:=
endif

# Darwin (Mac OS X 10.5 or 10.6, 64-bit).
ifeq (${TARGET},Darwin)
    LINK_ARGS:=
endif

################################################################################
# TARGETS
################################################################################

all: ${OUTPUT_NAME}${EXE_EXTN}

${OUTPUT_NAME}${EXE_EXTN}: preamble prep parser
	gnatmake -j${SPARKCPUS} ${GNATMAKE_OPTS} ${OUTPUT_NAME} -o $@ -bargs ${BIND_OPTS} -largs ${LINK_ARGS}

self-analysis: preamble prep parser
	-spark -plain @${OUTPUT_NAME}.smf

# Initialisations
# ===============

preamble:
	$(MAKE) -C ${ROOT}/examiner clean

# Platform specific prepping
# ==========================

prep:
	$(MAKE) -C ${ROOT}/examiner prep

parser:
	$(MAKE) -C ${ROOT}/examiner parser

# Cleaning code base
# ==================

clean: standardclean

reallyclean: clean targetclean vcclean preamble
	$(MAKE) -C ${ROOT}/examiner reallyclean

################################################################################
# END-OF-FILE
