=== debian/changelog ===
spark (2012.0.deb-8) unstable; urgency=medium

  * Make the package compatible with both bison 2 and 3 and stop requiring
    bison 3.

 -- Євгеній Мещеряков <eugen@debian.org>  Mon, 16 Dec 2013 10:59:24 +0100

spark (2012.0.deb-7) unstable; urgency=medium

  * Fix required bison version (add 2:)

 -- Євгеній Мещеряков <eugen@debian.org>  Fri, 13 Dec 2013 00:31:48 +0100

spark (2012.0.deb-6) unstable; urgency=medium

  * New patch:
    - vct-bison-3-fix.diff - fix building with bison 3
  * Build-depend on bison >= 3
  * Standards-Version 3.9.5 — no changes needed

 -- Євгеній Мещеряков <eugen@debian.org>  Thu, 12 Dec 2013 22:00:22 +0100

spark (2012.0.deb-5) unstable; urgency=low

  * Use swi_prolog dh seqence to declare dependencies on SWI Prolog VM.

 -- Євгеній Мещеряков <eugen@debian.org>  Sun, 12 May 2013 23:41:17 +0200

spark (2012.0.deb-4) unstable; urgency=low

  * Upload to unstable

 -- Євгеній Мещеряков <eugen@debian.org>  Tue, 07 May 2013 22:00:47 +0200

spark (2012.0.deb-3) experimental; urgency=low

  * Rename prolog module settings to spark_prolog_settings to avoid conflict
    with newer versions of SWI prolog
  * Remove public declaration of predefined predicate subset/2 to avoid
    compilation problem with new SWI prolog

 -- Євгеній Мещеряков <eugen@debian.org>  Sun, 30 Sep 2012 21:46:13 +0200

spark (2012.0.deb-2) experimental; urgency=low

  * Override the architecture detection and handle all architectures as
    "Linux". This should fix an FTBFS on kfreebsd-*.

 -- Євгеній Мещеряков <eugen@debian.org>  Sun, 08 Jul 2012 23:55:54 +0200

spark (2012.0.deb-1) experimental; urgency=low

  * New upstream release
  * Upload to experimental
  * Update patches:
    - debian-architecture-detect.diff
    - examiner-architecture-bits.diff 
    - checker-makefile.diff 
    - no-alt-ergo.diff 
    - victor-no-static-gmp.diff
    - simplifier-makefile.diff
    - victor-use-env-opt-flags.diff
    - ada-use-evn-optflags.diff
    - victor-gmpxx-as-needed.diff
    - makefile-gnatmake-par-envvar.diff
    - ada-link-env-flags.diff
  * Remove patches:
    - make-dependencies.diff - not needed anymore
    - makefile-gnatmake-par-envvar.diff - use SPARKCPUS variable instead 
  * Standards-Version 3.9.3 — no changes required
  * Update debian/copyright
  * Do not install /usr/lib/spark/current/spark_/

 -- Євгеній Мещеряков <eugen@debian.org>  Sat, 30 Jun 2012 23:21:48 +0200
