=== debian/control ===
Source: spark
Section: devel
Priority: optional
Maintainer: Євгеній Мещеряков <eugen@debian.org>
Build-Depends: debhelper (>= 8), gnat, swi-prolog-nox (>= 6.2.6-2~), libgmp-dev (>= 2:5.0.1+dfsg-7~), bison, flex
Standards-Version: 3.9.5
Homepage: http://libre.adacore.com/libre/tools/spark-gpl-edition/
Vcs-Git: git://git.debian.org/collab-maint/spark.git
Vcs-Browser: http://git.debian.org/?p=collab-maint/spark.git

Package: spark
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ${swi-prolog:Depends}, swi-prolog-nox
Suggests: gnat, alt-ergo
Description: SPARK programming language toolset
 SPARK is a formally-defined computer programming language based on the
 Ada programming language, intended to be secure and to support the
 development of high integrity software used in applications and systems
 where predictable and highly reliable operation is essential either for
 reasons of safety or for business integrity.
 .
 This package contains the tools necessary for checking if programs adhere
 to the SPARK rules and the tools to show freedom of runtime exceptions in
 those programs. To compile SPARK programs use any standards-compliant Ada
 compiler, such as GNAT.
