## spark analyzer-0.1.19

=== requirements.txt ===
setuptools>=60.0.0
tabulate>=0.8.10
requests>=2.28.1
configparser>=5.2.0
tqdm>=4.64.0
